<?php 

/**
 Hifiberry Setup Controller
 @Copyright 2015 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.max2play.com

 */

include_once(APPLICATION_PATH.'/controller/Start.php');

class Hifiberry_Setup extends Start {

	public $scriptPath = '';
	
	public $usbSoundCards = array('' => array('dtoverlay' => '', 'name' => 'none', 'squeezelite' => '-o default:CARD=ALSA -a 120:::', 'shairport' => '-d default:CARD=ALSA', 'mpd_mixer_control' => 'PCM'),
			'hifiberry-dac' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'hifiberry-daclight' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC+ Light (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'hifiberry-dacplus' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC+ (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),	        
			'hifiberry-dacpluspro' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC+ Pro (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-dacplusadc' =>  array('dtoverlay' => 'hifiberry-dacplusadc', 'name' => 'Hifi Berry DAC+ ADC (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-dacplusadcpro' =>  array('dtoverlay' => 'hifiberry-dacplusadcpro', 'name' => 'Hifi Berry DAC+ ADC PRO (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-dac2pro' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC2 Pro (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-dacplushd' =>  array('dtoverlay' => 'hifiberry-dacplushd', 'name' => 'Hifi Berry DAC2 HD (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'DAC', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-digi' => array('dtoverlay' => 'hifiberry-digi', 'name' => 'Hifi Berry Digi/Digi+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'hw:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital'),
			//Shairport kann hier kein Hardware Volume Control! 'hifiberry-amp' => array('dtoverlay' => 'hifiberry-amp', 'name' => 'Hifi Berry Amp/Amp+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:0 -V Master', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:0 -c Master', 'mpd_mixer_control' => 'Master'));
			'hifiberry-amp' => array('dtoverlay' => 'hifiberry-amp', 'name' => 'Hifi Berry Amp/Amp+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Master', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-amp2' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry AMP 2 (B+ / PI 2/3)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:1 -V Digital -C 5', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:1 -c Digital', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-amp3' =>  array('dtoverlay' => 'hifiberry-amp3', 'name' => 'Hifi Berry AMP 3 (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:1 -V Digital -C 5', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:1 -c Digital', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-amp100' =>  array('dtoverlay' => 'hifiberry-amp100', 'name' => 'Hifi Berry AMP 100 (PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:1 -V Digital -C 5', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:1 -c Digital', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-daczero' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC+ Zero (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-miniamp' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry MiniAmp (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'beocreate' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'BeoCreate', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:0 -V DSPVolume -C 5', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:0 -c DSPVolume', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'DSPVolume', 'amixercard' => 'sndrpihifiberry')
	);
	
	public $alsasettings = array(
    	    'hifiberry-dacplushd' => array(
    	        'DAC' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)')),      
	        'hifiberry-dacplus' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
    	    'hifiberry-dacplusadc' => array(
    	        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
    	        'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
    	        'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
            'hifiberry-dacplusadcpro' => array(
                'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
                'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
                'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
	        'hifiberry-amp2' => array(
    	        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
    	        'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
    	        'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
            'hifiberry-amp3' => array(
                'A.Mstr Vol' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)')),
                //'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
                //'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
            'hifiberry-amp100' => array(
                'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
                'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
                'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
	        'hifiberry-dacpluspro' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),		
			'hifiberry-dac' => array(
					'PCM' => array('min' => 0, 'max' => 100, 'description' => 'PCM Volume (Optimum 96%)')),
			'hifiberry-amp' => array(
					'Master' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Default 80%)')),
    	    'beocreate' => array(
    	        'DSPVolume' => array('min' => 0, 'max' => 100, 'description' => 'DSP-Volume (Sigma TCP-Server ALSA control)'))
	);
	
	public function __construct(){		
		parent::__construct();
		$this->pluginname = _('HiFiBerry');
		$this->registerLocale(dirname(__FILE__).'/../locale', 'hifiberry');
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		
		if($_REQUEST['ajax'] == 1){
		    if ($_REQUEST['action'] == 'installKernelPi'){
		        $this->_installKernelPi($ajax = 1);
		    }
		    if ($_REQUEST['action'] == 'save_dtoverlay'){
		        $this->_saveDtoverlay($ajax = 1);
		    }
		    ob_end_clean();
		    echo implode('<br />', $this->view->message);
		    ob_flush();
		    die();
		}
		
		$this->checkPicturesAndHeader('hifiberry', dirname(__FILE__));

		// alsamixerParameter is used to get % values instead of -db (linear scale instead of exponential volume change)
		$this->alsamixerParameter = '-M';
		
		$this->_getDTOverlayConfig();
		
		if(isset($_REQUEST['action'])){
			if($_REQUEST['action'] == 'save_dtoverlay'){
				$this->_saveDtoverlay();
				$this->_getDTOverlayConfig();
			}
			if($_REQUEST['action'] == 'save_alsa'){
				$this->_saveAlsa();
			}
			if($_REQUEST['action'] == 'save_dsp'){
			    $this->_saveDSP();
			}
			if($_REQUEST['action'] == 'installKernelPi'){	
			    $this->_installKernelPi($ajax = 0);
			}
		}
		
		if($this->getFreeDiskSpace()){
			if($this->info->freespace < 300){
				$this->view->message[] = str_replace('$FREESPACE', $this->info->freespace, _('Only $FREESPACE MB of free space left on the device! Did you already expand the filesystem?'));
			}				
		}
		$this->getAlsaAudio();		
		$this->easyinstaller = true;
	}
	
	private function _getDTOverlayConfig(){
		$this->view->dtoverlay = $this->getConfigFileParameter('/opt/max2play/options.conf', 'audiocard');
		if($this->view->dtoverlay == ''){
			$this->view->message[] = _t('You have not yet choosen your installed HiFiBerry card! You must do this before you can use your audioplayers with your HiFiBerry card! Please choose your card and finish the setup below.');
		}
		
		
		// When Amp2 is choosen check correct position of Amp soundcard!
		if($this->view->dtoverlay == 'hifiberry-amp2' || $this->view->dtoverlay == 'beocreate'){
		    $cardposition = $this->writeDynamicScript(array('aplay -l | grep -o \'card [0-9]\+: '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].'\''));
		    if(strlen($cardposition) > 0){
		        // card is already loaded and available
		        // output is somthing like: "card 0: sndrpihifiberry"
		        $cardnumber = substr($cardposition, 5, 1);
		        //get current setup for hw:X
		        if(preg_match('=hw:([0-9]+)=', $this->getConfigFileParameter('/opt/max2play/audioplayer.conf', 'SQUEEZELITE_PARAMETER'), $sqlitematch) && intval($cardnumber) != $sqlitematch[1] || 
		            preg_match('=hw:([0-9]+)=', $this->getConfigFileParameter('/opt/max2play/audioplayer.conf', 'SHAIRPORT_PARAMETER'), $shairportmatch) && intval($cardnumber) != $shairportmatch[1]){	          
		            
		                $this->view->message[] = str_replace('$POSITION', $cardnumber, _t('<b>Important:</b> The chosen soundcard is located at hw:$POSITION but the settings for squeezelite and shairport in the advanced options in the audioplayer tab are not pointing to hw:$POSITION ! You need to change this to get your audio card working correctly!'));
		        }
		    }
		    if($this->view->dtoverlay == 'beocreate'){
		        // Offer DSP Profile Setup
		        // Get Profiles from http://downloads.hifiberry.com/beocreate/profiles/
		        // Get Installer from https://github.com/hifiberry/beocreate-tools/blob/master/install-dsp-profile
		        $this->view->dsp_profiles = explode("\n", trim($this->shell_exec('ls '.$this->scriptPath.'beocreate | grep xml')));
		    }
		}
		if($this->view->dtoverlay == 'hifiberry-dacplusadc'){
		    if(method_exists($this, 'Rpi_functions')){
		        $Rpi_functions = $this->Rpi_functions();
		        if (method_exists($Rpi_functions, 'compareKernelVersion')){
		            $updateKernel = $Rpi_functions->compareKernelVersion('4.18.12'); // needs at least 4.18.12
		            if($updateKernel)
		                $this->view->message[] = str_replace(array('$CARDNAME', '$VERSION'),array($this->usbSoundCards[$this->view->dtoverlay]['name'], '4.18.12'), _t('<b>Important</b>: The $CARDNAME needs at least Kernel Version $VERSION to work! <a href="?action=installKernelPi">Click here to install latest Kernel now!</a> Otherwise your soundcard will not work.'));
		        }
		    }
		}
		if($this->view->dtoverlay == 'hifiberry-dacplushd'){
		    if(method_exists($this, 'Rpi_functions')){
		        $Rpi_functions = $this->Rpi_functions();
		        if (method_exists($Rpi_functions, 'compareKernelVersion')){
		            $updateKernel = $Rpi_functions->compareKernelVersion('4.19.97'); // needs at least 4.19.97
		            if($updateKernel)
		                $this->view->message[] = str_replace(array('$CARDNAME', '$VERSION'),array($this->usbSoundCards[$this->view->dtoverlay]['name'], '4.19.97'), _t('<b>Important</b>: The $CARDNAME needs at least Kernel Version $VERSION to work! <a href="?action=installKernelPi&version=e1050e9">Click here to install latest Kernel now!</a> Otherwise your soundcard will not work.'));
		        }
		    }
		}
		return true;
	}
	
	private function _saveDtoverlay($ajax = 0){
		if(isset($_REQUEST['dtoverlay']) && in_array($_REQUEST['dtoverlay'], array_keys($this->usbSoundCards))){
		    if ($ajax == 0){
		        $this->saveDTOverlayConfig($this->usbSoundCards[$_REQUEST['dtoverlay']]['dtoverlay'], 'soundcard');
    			$this->saveConfigFileParameter('/opt/max2play/options.conf', 'audiocard', $_REQUEST['dtoverlay']);
    			//Set Squeezelite Parameter
    			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SQUEEZELITE_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['squeezelite']);
    			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SHAIRPORT_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['shairport']);			
    						
    			//MPD Parameter HifiBerry
    			if(file_exists('/etc/mpd.conf')){
    				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_control', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_mixer_control'].'\"', $separator = '\\t');
    				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'format', $value = '\"192000:24:2\"', $separator = '\\t');
    				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'device', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_device'].'\"', $separator = '\\t');
    				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_device', $value = '\"'.$this->getSoundcardPosition('sndrpihifiberry').'\"', $separator = '\\t');
    			}						
    			
    			$this->view->message[] = _("Boot config parameters changed");
		    }
			if($_REQUEST['dtoverlay'] == 'beocreate'){			    			   
			    if ($ajax == 0) {
			        // Install TCP Driver https://www.hifiberry.com/beocreate/beocreate-doc/beocreate-installing-the-sigmatcpserver/
			        // Enable dtparam=spi=on with RPI_Functions
			        $Rpi_functions = $this->Rpi_functions();
			        $Rpi_functions->saveDTParamConfig('spi=on', 'spi');
			        $this->view->message[] = _("Enabled SPI in boot/config.txt");
			        $this->setBuildInAudio(false);
			        $this->view->message[] = _("<b>Disabled Build-In Audio to make sure Beocreate Card is in position 0</b>");
			        $this->view->message[] = "";
			        
			        if ($this->getProgressWithAjax('/opt/max2play/cache/install_beocreate.txt', 1, 1, 30, $message = false, $url = false, $failmessage = false, $finishedText = 'Finished Installing')) {
			            $shellanswer = $this->writeDynamicScript(array(
			                $this->scriptPath . "beocreate/install_tcp_beocreate.sh >> /opt/max2play/cache/install_beocreate.txt 2>&1 &"
			            ), false, true);
			        }
			        return true;
			    } else {
			        $status = $this->getProgressWithAjax('/opt/max2play/cache/install_beocreate.txt', 0, 1, 30);
			        $this->view->message[] = nl2br($status);
			        if (strpos($status, 'Finished Installing') !== FALSE) {
			            // Finished Progress - did not delete progressfile yet
			            shell_exec('rm /opt/max2play/cache/install_beocreate.txt');
			            $this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
			        }
			        return true;
			    }
			}
			$this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
		}		
		return true;
	}
    
	/**
	 * Important! dtoverlay Parameter might be set multiple times in config.txt -> separate handling needed
	 * @param string $value
	 * @param string $dto_type Possible values: soundcard, single_option
	 * @return boolean
	 */
	private function saveDTOverlayConfig($value = '', $dto_type = 'notset', $dto_param = ''){
	    $dto_entries['soundcard'] = array();
	    
	    // NEW Method!
	    if(method_exists($this, 'Rpi_functions')){
	        $Rpi_functions = $this->Rpi_functions();
	        if($dto_param != '') // For Lirc
	            $value = $value.','.$dto_param;
	            $rpi_Object = get_object_vars($Rpi_functions);
	            if(isset($rpi_Object['usbSoundCards'])){
	                foreach($rpi_Object['usbSoundCards'] as $card){
	                    if (isset($card['dtoverlay']) && $card['dtoverlay'] != '')
	                        $dto_entries['soundcard'][] = $card['dtoverlay'];
	                }
	            }
	            // Bugfix for Private Method in RPI-Functions...
	            if(in_array('saveDTOverlayConfig', get_class_methods($Rpi_functions))){
	                $Rpi_functions->saveDTOverlayConfig($value, $dto_type);
	                return true;
	            }
	    }
	}
	
	/**
	 * get soundcard position e.g. hw:0 or hw:1
	 * @param string $soundcard
	 * @return string for MPD mixer_device
	 */
	private function getSoundcardPosition($soundcard = ''){
		$aplayOutput = $this->writeDynamicScript(array('LANG=C && aplay -l | grep "card"'));
		//card 0: ALSA [bcm2835 ALSA], device 1: bcm2835 ALSA [bcm2835 IEC958/HDMI]
		//card 1: IQaudIODAC [IQaudIODAC], device 0: IQaudIO DAC HiFi pcm512x-hifi-0 []
		if(!preg_match_all('=^card ([0-9]): ([^ ]*)=im', $aplayOutput, $aplayMatches))
			return 'default';
		$count = count($aplayMatches[1]);
		$aplayCards = array();
		for($i = 0; $i < $count; $i++){
			$aplayCards[$aplayMatches[2][$i]] = $aplayMatches[1][$i];
		}
		if(isset($aplayCards[$soundcard]))
			return 'hw:'.$aplayCards[$soundcard];
		else
			return 'default';
	}
	
	/**
	 * get Alsa Settings For AudioCard
	 */
	public function getAlsaAudio(){
		$this->view->alsavalues = false;
		if($this->view->dtoverlay && isset($this->alsasettings[$this->view->dtoverlay])){
			$user = $this->getSystemUser();
			if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
				$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
			}else{
				$amixercard = '';
			}
			foreach($this->alsasettings[$this->view->dtoverlay] as $key => $value){
				$script = array('su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' sget "'.$key.'"\'');
				$output = $this->writeDynamicScript($script);
				preg_match('=\[([^\]]*)\]=', $output, $match);
				if(isset($match[1])){
					$this->view->alsavalues[$key] = $value;
					if(strpos($match[1], '%') !== FALSE)
						$this->view->alsavalues[$key]['type'] = '%';
					else
						$this->view->alsavalues[$key]['type'] = '';
					$this->view->alsavalues[$key]['value'] = intval($match[1]);
				}
			}
		}
		return true;
	}
	
	public function _saveAlsa(){
		$user = $this->getSystemUser();
		$this->getAlsaAudio();
		$script = array();
		if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
			$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
		}else{
			$amixercard = '';
		}
		foreach($this->view->alsavalues as $key => $value){
			$script[] = 'su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' -q set "'.$key.'" '.$_REQUEST[str_replace(array(' ','.'),array('_','Q'), $key)].$value['type'].'\'';
			$script[] = 'su - '.$user.' -c \'alsactl store\'';
		}
		if(isset($script[0])){
			$output = nl2br($this->writeDynamicScript($script));
			if($output != '')
				$this->view->message[] = $output;
			$this->view->message[] = _("Updated Alsa Settings");
		}
		return true;
	}
	
	/**
	 * Change Kernel for drivers on Raspberry Pi
	 * @param number $ajax
	 * @return boolean
	 */
	private function _installKernelPi($ajax = 0){
	    $outfile = '/opt/max2play/cache/upgradeSystem.txt';
	    if($ajax == 0){
	        $version = '';
	        if(isset($_REQUEST['version'])){
	            $version = preg_replace('@[^a-z0-9]@', '', $_REQUEST['version']).' ';
	        }
	        ignore_user_abort(true);
	        set_time_limit(3000);
	        $this->view->message[] = _('Kernel Update started');
	        if($this->getProgressWithAjax($outfile, 1, 0)){
	            //run it as a deamon to enable apache updates
	            $shellanswer = $this->writeDynamicScript(array("SKIP_WARNING=1 rpi-update $version>> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/hifiberry/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
	        }
	    }else{
	        $status = $this->getProgressWithAjax($outfile, 0, 0, 30);
	        $this->view->message[] = nl2br($status);
	        if(strpos($status, 'Finished') !== FALSE){
	            //Finished Progress - did not delete progressfile
	            shell_exec('rm '.$outfile);
	        }
	    }
	    return true;
	}
	
	public function _saveDSP(){
	    if(isset($_REQUEST['dsp_profile']) && file_exists($this->scriptPath."beocreate/".$_REQUEST['dsp_profile']))
	       $this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath."beocreate/install_dsp_profile.sh ".$this->scriptPath."beocreate/".$_REQUEST['dsp_profile'])));
	    else{
	       $this->view->message[] = _t('Missing DSP-Profile'); 
	    }
	    return true;
	}
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Introduction');
		$helpSidebar['content'] = _t('<ul><li>You want to know more about this special Max2Play-Version? You may watch <a target="_blank" href="https://youtu.be/AOlHpEcVEYE">a video tutorial about the settings on this page</a>.</li></ul>');
		$helpSidebar['toppicture'] = '/images/start-toppicture.jpg';
		return true;
	}
}

$start = new Hifiberry_Setup();

include_once(dirname(__FILE__).'/../view/setup.php');

